package com.jkcredit.invoice.hub.controller.web.rolePermission;

import com.jkcredit.invoice.hub.controller.base.WebResource;
import com.jkcredit.invoice.hub.controller.web.rolePermission.fb.RolePermissionFB;
import com.jkcredit.invoice.hub.model.dto.rolePermission.RolePermissionDto;
import com.jkcredit.invoice.hub.service.rolePermission.RolePermissionService;
import com.jkcredit.invoice.hub.spi.lang.exception.ServiceException;
import com.jkcredit.invoice.hub.spi.web.data.ResponseData;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

/**
 * @description:
 * @author: xusonglin
 * @create: 2020/1/14 22:54
 * @version: V1.0
 **/
@Slf4j
@RestController
public class RolePermissionResource extends WebResource {
    @Autowired
    RolePermissionService rolePermissionService;

    @PreAuthorize("hasPermission('permission','edit')")
    @PostMapping("/rolePermission")
    public ResponseData addRolePermission(@RequestBody RolePermissionFB rolePermissionFB) {
        try {
            validate(rolePermissionFB);
            RolePermissionDto dto = mapper.map(rolePermissionFB, RolePermissionDto.class);
            rolePermissionService.saveRolePermission(dto);
            return ResponseData.success("添加成功");
        } catch (ServiceException e) {
            return ResponseData.failed("添加失败，失败原因" + e.getMessage());
        }
    }
}
